If CommandLine$()="/window" Then Graphics 640,480,0,2 ElseIf CommandLine$()="/stretch" Then Graphics 640,480,0,3 Else Graphics 640,480
SetBuffer BackBuffer()			;----------------------------------------;
Dim minefield(30,30)			;   150 Lines Game Competition Entry.    ;
Type particle					; (C) Jan/Feb 2003 Andrew Pointon (TCK)  ;
	Field x#,y#,xs#,ys#,life	;----------------------------------------;
End Type
Global lx,ly,level=1,plx#=240, ply#=472, dx#, dy#, plangle#=180,score=0, speed#=0, gravity_on=True, highscore, bonus, gametimer=CreateTimer(60),create=1,thrust=LoadSound("media\thrust.wav"),explode=LoadSound("media\explode.wav"),resuesound=LoadSound("media\woohoo.wav"),soundeffect,ingame=LoadImage("media\ingame.png"),title=LoadImage("media\title.png"), ship=LoadAnimImage("media\ship.png",20,20,0,72),spaceman=LoadAnimImage("media\spaceman.png",20,20,0,36),starfield=LoadImage("media\starfield.png"),win=LoadImage("media\win.png"),lose=LoadImage("media\gameover.png"),lazer=LoadAnimImage("media\lazer.png",32,32,0,4),lazereffect=LoadSound("media\electric.wav"),lazersound
.titlescreen
level=1
lives=3
create=1
Flip
	If KeyHit(1) Then End Else Cls
	TileImage starfield,0,-439+((MilliSecs()/50) Mod 439)
	DrawImage title,0,0
	Text 320,440,"Last Score was "+Left$("000000",6-Len(score))+score,1,1
	Text 320,460,"Todays Highest Score is "+Left$("000000",6-Len(highscore))+highscore,1,1
If Not KeyHit(57) Then Goto titlescreen Else score=0
.levelstart
If create=1 Then bonus=5000+(level-1)*1000	;set level start-bonus
SeedRnd level*1999
Repeat 
	If minefield(Floor(plx/16),Floor(ply/16))=10 Then PlaySound(resuesound) 
	If minefield(Floor(plx/16),Floor(ply/16))=10 Then score=score+5000 	
	adjacent=(minefield(Floor(plx/16)-1,Floor(ply/16))=2)+(minefield(Floor(plx/16)+1,Floor(ply/16))=2)+(minefield(Floor(plx/16),Floor(ply/16)+1)=2)+(minefield(Floor(plx/16),Floor(ply/16)-(ply>16))=2)
	minefield(Floor(plx/16),Floor(ply/16))=3+adjacent
	If KeyDown(203) Then plangle=(plangle+5) Mod 360 ElseIf KeyDown(205) Then plangle=(plangle+355) Mod 360
	If KeyDown(57)
		speed#=speed#+.01
		AddParticle(1)
		If Not ChannelPlaying(soundeffect) Then soundeffect=PlaySound(thrust)
 	Else speed#=speed#-.0075
	EndIf	
	If speed#<0 Then speed#=0 ElseIf speed#>.1 Then speed#=.1
	dx=dx+(Sin(plangle)*speed#)
	dy=dy+(Cos(plangle)*speed#)
	If plx+dx<24 Or plx+dx>456 Then dx=-dx
	If ply+dy<8 Or ply+dy>472 Then dy=-dy		
	plx=plx+dx
	ply=ply+dy
	If gravity_on Then dy=dy+.003	
	If dx>0 Then dx=dx-Abs(dx/20) ElseIf dx<0 Then dx=dx+Abs(dx/20)
	If dx>3 Then dx=3 ElseIf dx<-3 Then dx=-3
	If dy>(gravity_on*2) Then dy=dy-Abs(dy/20) ElseIf dy<0 Then dy=dy+Abs(dy/20)
	If dy>3 Then dy=3 ElseIf dy<-3 Then dy=-3
	If (level Mod 2)=0
		If ly=-64 Then lx=24+Rand(432)
		ly=ly+3	
		If (create Or ly>550) Then ly=-64
		If ly>-60 And ly<480 And (Not(ChannelPlaying(lazersound))) Then lazersound=PlaySound(lazereffect) 	
	EndIf
	RenderScreen	; draw the screen, with scores, etc
	If (level Mod 2)=0 Then DrawImage lazer,lx,ly,Rand(0,3)
	create=0
	DrawImage ship,plx-10,ply-10,Floor(plangle/5)	; draw player ship
	If bonus>0 Then bonus=bonus-1	; if there is still a bonus left then reduce it by one point
	WaitTimer gametimer
	Flip False
	Cls
Until ply<10 Or (minefield(Floor(plx/16),Floor(ply/16))=2) Or ((level Mod 2)=0 And ImagesCollide(lazer,lx,ly,0,ship,plx,ply,Floor(plangle/5)))
If (minefield(Floor(plx/16),Floor(ply/16))=2) Or ((level Mod 2)=0 And ImagesCollide(lazer,lx,ly,0,ship,plx,ply,Floor(plangle/5))) Then soundeffect=PlaySound(explode) ElseIf ply<=10 Then level=level+1
If (minefield(Floor(plx/16),Floor(ply/16))=2) Or ((level Mod 2)=0 And ImagesCollide(lazer,lx,ly,0,ship,plx,ply,Floor(plangle/5))) Then lives=lives-1 ElseIf ply<=10 Then score=score+bonus
If (minefield(Floor(plx/16),Floor(ply/16))=2) Then minefield(Floor(plx/16),Floor(ply/16))=1 ElseIf ((level Mod 2)=0 And ImagesCollide(lazer,lx,ly,0,ship,plx,ply,Floor(plangle/5))) Then ly=0 ElseIf ply<=10 Then create=1 
plx#=240
ply#=472
dy=0
dx=0
angle=180
ly=-64
If lives>0 And level<=25 Then Goto levelstart
For End=1 To 200
	RenderScreen
	If ply<10 And level=25 Then DrawImage win,90,220 Else DrawImage lose,90,220
	
	WaitTimer gametimer
	Flip False
	Cls
Next
Color 255,255,255
If score>highscore Then highscore=score
FlushKeys
Goto titlescreen
Function AddParticle(kind)	;particle creation function, creates different particles depending on circumstances ;)
		dot.particle = New particle	
		If kind=1 Then dot\x=plx-Sin(plangle)*4 Else dot\x=plx-10
		If kind=1 Then dot\y=ply-Cos(plangle)*4 Else dot\y=ply-10
		If kind=1 Then dot\xs#=-Sin((plangle)+Rnd(-15,15)) Else dot\xs#=Rnd(-3,3)
		If kind=1 Then dot\ys#=-Cos((plangle)+Rnd(-15,15)) Else dot\ys#=Rnd(-3,3)
		dot\life=Rnd(200,255)
End Function
Function RenderScreen()	;draw the screen and the scores, etc
	TileImage starfield,0,-439+((MilliSecs()/50) Mod 439)
	For n=1 To 29
		For m=0 To 30
			Color 255*((minefield(n,m)-3)>0),255*((minefield(n,m)-3)<=1),128 
			If create Then If m>0 And m<29 And Rnd(0,150)<=level+2 Then minefield(n-(n>0),m)=2 Else minefield(n-(n>0),m)=0
			If create Then minefield(14,15)=2 ElseIf ((minefield(Floor(plx/16),Floor(ply/16))=2) Or ((level Mod 2)=0 And ImagesCollide(lazer,lx,ly,0,ship,plx,ply,Floor(plangle/5)))) And n<7 Then AddParticle(2)
			If create Then minefield(15,15)=2 ElseIf (minefield(n,m)>2 And minefield(n,m)<10) Then Text n*16+8,m*16+8,(minefield(n,m)-3),1,1 ElseIf minefield(n,m)=1 Then Text n*16+8,m*16+8,"X",1,1 ElseIf minefield(n,m)=10 Then DrawImage spaceman,n*16-2,m*16-2,((MilliSecs()/25)Mod 36)
			;Color 128,0,128: minefield(n,m)=2 Then Oval n*16+4,m*16+4,8,8,1 ;debug - show mines
			If (create And (level Mod 3)=0) Then manpos=Rand(1,8)
		Next
	Next
	If KeyHit(1) Then End Else DrawImage ingame,0,0
	If (create And (level Mod 3)=0) Then minefield(manpos,15)=10 Else Color 255*(adjacent>0),255*(adjacent<=1),128
	If (create And (level Mod 3)=0) Then minefield(29-manpos,15)=10 Else Text 560,420,"* "+adjacent+" *",1,1 
	Color 200,150,200
	Text 560,100,lives,1,1
	Text 560,150,Left$("0",2-Len(level))+level,1,1
	Text 560,200,Left$("000000",6-Len(score))+score,1,1
	Text 560,250,Left$("00000",5-Len(bonus))+bonus,1,1
	For dot.particle = Each particle	
		Color Rand(dot\life),0,0
		Rect dot\x-1,dot\y-1,2,2		
		dot\x=dot\x+dot\xs#		
		dot\y=dot\y+dot\ys#		
		dot\life = dot\life - 3
		If dot\life<=0 Or dot\x>480 Then Delete dot
	Next
End Function